Eosc/easybuild/modules

From Nordic Language Processing Laboratory
Revision as of 16:14, 5 November 2021 by Andreku (talk | contribs) ("Regular" modules)
(diff) ← Older revision | Latest revision (diff) | Newer revision → (diff)
Jump to: navigation, search

NLPL virtual laboratory

The laboratory is a reproducible custom-built set of NLP software. It is currently installed on Saga and Puhti HPC clusters.

To use on Saga: run the following command on (can be put in the ~/.bashrc file to be run automatically at login):

module use -a /cluster/shared/nlpl/software/eb/etc/all/

After that, the "nlpl"-branded modules will be available via module avail, module load, etc.

It is highly recommended to use them, instead of installing a copy in one's own home directory.

List of modules

From time to time, updated modules with newer software versions will be added, but the older modules will never be removed (for reproducibility).

Note that the modules which have "gomkl" in their names are built using Intel Math Kernel Library, making them significantly faster in CPU tasks with Intel processors.

Those with "foss" instead of "gomkl" are CPU-agnostic and will run OK on AMD machines.

"Bundle" modules

These are the modules with the most cryptic names. Each of them contains a bunch of software pieces (Python packages, as a rule). Many of these modules will be loaded automatically as dependencies of the regular modules, but sometimes they can be useful themselves. Here are the details:

  • nlpl-python-candy/2021.01-gomkl-2019b-Python-3.7.4: various utility packages not directly related to NLP
    • tqdm 4.62.3
    • pydot 1.4.2
    • smart_open 5.2.1
    • cached-property 1.5.2
    • filelock 3.0.12
    • regex 2021.10.23
    • sacremoses 0.0.46
    • mpi4py 3.1.1
    • jsonlines 2.0.0
  • nlpl-nlptools/2021.01-gomkl-2019b-Python-3.7.4: various utility packages related to NLP
    • conllu 4.4.1
    • seqeval 1.2.2
    • langdetect 1.0.9
    • leven 1.0.4
  • nlpl-scipy-ecosystem/2021.01-gomkl-2019b-Python-3.7.4: everything that constitutes the SciPy ecosystem. Too many packages to enumerate them all, but the most important are:
    • scipy 1.5.4
    • pandas 1.2.1
    • matplotlib 3.1.2
    • ipython 7.11.1
    • jupyter_core 4.6.1
    • jupyter_client 5.3.4
    • networkx 2.5.1
    • sympy 1.7.1

"Regular" modules

These are more obvious modules, each one gives you one software piece:

  • nlpl-cython/0.29.21-gomkl-2019b-Python-3.7.4: Cython 0.29.21
  • nlpl-dllogger/0.1.0-gomkl-2019b-Python-3.7.4: DLLogger 0.1.0
  • nlpl-gensim/3.8.3-gomkl-2019b-Python-3.7.4: Gensim 3.8.3
  • nlpl-horovod/0.20.3-gomkl-2019b-tensorflow-1.15.2-Python-3.7.4: Horovod 0.20.3
  • nlpl-nltk/3.5-gomkl-2019b-Python-3.7.4: NLTK 3.5, together with all the corpora and datasets (no need to download them separately!)
  • nlpl-numpy/1.18.1-gomkl-2019b-Python-3.7.4: NumPy 1.18.1
  • nlpl-nvidia-bert/20.06.8-gomkl-2019b-tensorflow-1.15.2-Python-3.7.4: NVIDIA's BERT implementation for TensorFlow 1
  • nlpl-pytorch/1.6.0-gomkl-2019b-cuda-10.1.243-Python-3.7.4: PyTorch 1.6.0
  • nlpl-scikit-bundle/0.22.2.post1-gomkl-2019b-Python-3.7.4: Scikit-Learn 0.22.2
  • nlpl-simple_elmo/0.9.0-gomkl-2019b-Python-3.7.4: Simple_elmo 0.9.0
  • nlpl-stanza/1.1.1-gomkl-2019b-Python-3.7.4: Stanza 1.1.1
  • nlpl-tensorflow/1.15.2-gomkl-2019b-cuda-10.1.243-Python-3.7.4: TensorFlow 1.15.2
  • nlpl-tensorflow/2.3.2-gomkl-2019b-cuda-10.1.243-Python-3.7.4: TensorFlow 2.3.2
  • nlpl-tokenizers/0.10.2-gomkl-2019b-Python-3.7.4: HuggingFace Tokenizers 0.10.2
  • nlpl-transformers/4.5.1-gomkl-2019b-Python-3.7.4: HuggingFace Transformers 4.5.1
  • nlpl-wandb/0.12.6-gomkl-2019b-Python-3.7.4: Weights and Biases (wandb) 0.12.6
  • sentencepiece/0.1.94-gomkl-2019b-Python-3.7.4: SentencePiece 0.1.94

Source

Currently, the virtual laboratory is generated using EasyBuild, all the code and easyconfigs available here.